"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonParameter = void 0;
const JsonSchemaMapperContainer_1 = require("../registries/JsonSchemaMapperContainer");
const JsonMap_1 = require("./JsonMap");
const JsonParameterTypes_1 = require("./JsonParameterTypes");
class JsonParameter extends JsonMap_1.JsonMap {
    $kind = "operationInParameter";
    nestedGenerics = [];
    groups;
    groupsName;
    $schema;
    expression;
    getName() {
        const name = this.get("name");
        if (this.get("in") === "files") {
            return name.split(".")[0];
        }
        return name;
    }
    name(name) {
        this.set("name", name);
        return this;
    }
    examples(examples) {
        super.set("examples", examples);
        return this;
    }
    description(description) {
        this.set("description", description);
        return this;
    }
    in(inType, expression = "") {
        this.set("in", (0, JsonParameterTypes_1.formatParameterType)(inType));
        this.expression = expression;
        return this;
    }
    required(required) {
        this.set("required", required);
        return this;
    }
    schema(schema) {
        this.$schema = schema;
        return this;
    }
    toJSON(options) {
        return (0, JsonSchemaMapperContainer_1.execMapper)("operationInParameter", [this], options);
    }
}
exports.JsonParameter = JsonParameter;
//# sourceMappingURL=JsonParameter.js.map