"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isParameterType = exports.formatParameterType = exports.JsonParameterTypes = void 0;
var JsonParameterTypes;
(function (JsonParameterTypes) {
    JsonParameterTypes["BODY"] = "body";
    JsonParameterTypes["PATH"] = "path";
    JsonParameterTypes["QUERY"] = "query";
    JsonParameterTypes["HEADER"] = "header";
    JsonParameterTypes["COOKIES"] = "cookie";
    JsonParameterTypes["FILES"] = "files";
})(JsonParameterTypes = exports.JsonParameterTypes || (exports.JsonParameterTypes = {}));
/**
 * @ignore
 */
function formatParameterType(type) {
    return String(type).toLowerCase().replace("raw_", "").replace("cookies", "cookie");
}
exports.formatParameterType = formatParameterType;
/**
 * @ignore
 */
function isParameterType(type) {
    return Object.values(JsonParameterTypes).includes(formatParameterType(type));
}
exports.isParameterType = isParameterType;
//# sourceMappingURL=JsonParameterTypes.js.map