"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.oneOfMapper = exports.hasMapper = exports.execMapper = exports.getJsonSchemaMapper = exports.registerJsonSchemaMapper = void 0;
/**
 * @ignore
 */
const JsonSchemaMappersContainer = new Map();
/**
 * @ignore
 */
function registerJsonSchemaMapper(type, mapper, spec) {
    return JsonSchemaMappersContainer.set(spec ? `${spec}:${type}` : type, mapper);
}
exports.registerJsonSchemaMapper = registerJsonSchemaMapper;
/**
 * @ignore
 */
function getJsonSchemaMapper(type, options) {
    const mapper = JsonSchemaMappersContainer.get(`${options?.specType}:${type}`) || JsonSchemaMappersContainer.get(type);
    if (mapper) {
        return mapper;
    }
    // istanbul ignore next
    throw new Error(`JsonSchema ${type} mapper doesn't exists`);
}
exports.getJsonSchemaMapper = getJsonSchemaMapper;
/**
 * @ignore
 */
function execMapper(type, args, options, parent) {
    return getJsonSchemaMapper(type, options)(...args, options, parent);
}
exports.execMapper = execMapper;
function hasMapper(type) {
    return JsonSchemaMappersContainer.has(type);
}
exports.hasMapper = hasMapper;
function oneOfMapper(types, options) {
    return (types.find((type) => JsonSchemaMappersContainer.has(`${options?.specType}:${type}`)) ||
        types.find((type) => JsonSchemaMappersContainer.has(type)));
}
exports.oneOfMapper = oneOfMapper;
//# sourceMappingURL=JsonSchemaMapperContainer.js.map