"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getComputedType = void 0;
const core_1 = require("@tsed/core");
/**
 * @ignore
 */
function getComputedType(target) {
    if ((0, core_1.isPromise)(target) || target === Function) {
        return Object;
    }
    if ((0, core_1.isClass)(target) ||
        (0, core_1.isSymbol)(target) ||
        (0, core_1.isPrimitiveOrPrimitiveClass)(target) ||
        (0, core_1.isClassObject)(target) ||
        (0, core_1.isDate)(target) ||
        (0, core_1.isCollection)(target)) {
        return (0, core_1.classOf)(target);
    }
    if ((0, core_1.isArrowFn)(target)) {
        return target();
    }
    return target;
}
exports.getComputedType = getComputedType;
//# sourceMappingURL=getComputedType.js.map