"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getOperationsStores = void 0;
const JsonMethodStore_1 = require("../domain/JsonMethodStore");
const JsonOperationPathsMap_1 = require("../domain/JsonOperationPathsMap");
const getInheritedStores_1 = require("./getInheritedStores");
const getJsonEntityStore_1 = require("./getJsonEntityStore");
/**
 * @ignore
 */
function getOperationsStores(target) {
    const store = target.isStore ? target : (0, getJsonEntityStore_1.getJsonEntityStore)(target);
    if (!store.$operations) {
        const operationPaths = new JsonOperationPathsMap_1.JsonOperationPathsMap();
        store.$operations = new Map();
        (0, getInheritedStores_1.getInheritedStores)(store).forEach((currentStore) => {
            currentStore.children.forEach((propStore) => {
                if (propStore instanceof JsonMethodStore_1.JsonMethodStore && !store.$operations.has(propStore.propertyKey)) {
                    store.$operations.set(propStore.propertyKey, propStore);
                }
            });
        });
        store.$operations.forEach((store) => {
            store.operation.operationPaths.forEach((operationPath) => {
                operationPaths.setOperationPath(operationPath);
            });
        });
        operationPaths.clear();
    }
    return store.$operations;
}
exports.getOperationsStores = getOperationsStores;
//# sourceMappingURL=getOperationsStores.js.map