"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withErrorMsg = void 0;
const core_1 = require("@tsed/core");
const errorMsg_1 = require("../decorators/common/errorMsg");
function withErrorMsg(errorKey, originalDecorator) {
    const schema = {};
    return ((...decoratorOptions) => {
        const decorator = (0, core_1.useDecorators)(originalDecorator(...decoratorOptions));
        decorator.Error = (message) => {
            schema.message = message;
            return (0, core_1.useDecorators)(decorator, schema.message && (0, errorMsg_1.ErrorMsg)({ [errorKey]: message }));
        };
        return decorator;
    });
}
exports.withErrorMsg = withErrorMsg;
//# sourceMappingURL=withErrorMsg.js.map