import { __decorate } from "tslib";
import { DecoratorTypes } from "@tsed/core";
import { JsonEntityStore } from "./JsonEntityStore.js";
import { JsonSchema } from "./JsonSchema.js";
import { JsonEntityComponent } from "../decorators/config/jsonEntityComponent.js";
let JsonClassStore = class JsonClassStore extends JsonEntityStore {
    /**
     * List of children JsonEntityStore (properties or methods or params)
     */
    children = new Map();
    get path() {
        return this.store.get("path", "/");
    }
    set path(path) {
        this.store.set("path", path);
    }
    build() {
        if (!this._type) {
            this.buildType(this.target);
        }
        this._type = this._type || Object;
        this._schema = JsonSchema.from({
            type: this.type
        });
    }
};
JsonClassStore = __decorate([
    JsonEntityComponent(DecoratorTypes.CLASS)
], JsonClassStore);
export { JsonClassStore };
//# sourceMappingURL=JsonClassStore.js.map