import { Type } from "@tsed/core";
import { OpenSpecHash, OpenSpecRef, OS3Example, OS3Parameter } from "@tsed/openspec";
import { JsonSchemaOptions } from "../interfaces/JsonSchemaOptions";
import { NestedGenerics } from "../utils/generics";
import { JsonMap } from "./JsonMap";
import { JsonSchema } from "./JsonSchema";
export declare class JsonParameter extends JsonMap<OS3Parameter<JsonSchema>> implements NestedGenerics {
    $kind: string;
    nestedGenerics: Type<any>[][];
    groups: string[];
    groupsName: string;
    $schema: JsonSchema;
    expression: string;
    getName(): any;
    name(name: string): this;
    examples(examples: OpenSpecHash<OS3Example | OpenSpecRef>): this;
    description(description: string): this;
    in(inType: string, expression?: string | any): this;
    required(required: boolean): this;
    schema(schema: JsonSchema): this;
    toJSON(options?: JsonSchemaOptions): any;
}
